local _,ns = ...


local z = ns.Utils.crearFrameConTextura(ns.f,3,215,0,331,1)
z:SetPoint("CENTER", ns.f, "CENTER")
ns.FrameSetup(z,"Protected")
local scrollFrame
local textArea

local function setTooltip(parentFrame,...)
    local text1,text2,text3,text4=...
    parentFrame:HookScript("OnEnter", function(self)
        GameTooltip:SetOwner( parentFrame, "ANCHOR_NONE" );
        GameTooltip:SetPoint("TOPLEFT", z, "BOTTOMLEFT", -2, -4)
        if text1 then
        --print(HIGHLIGHT_FONT_COLOR_CODE..text1..FONT_COLOR_CODE_CLOSE)
            GameTooltip:AddLine(NORMAL_FONT_COLOR_CODE..text1..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        if text2 then
            GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..text2..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        if text3 then
            GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..text3..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        if text4 then
            GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..text4..FONT_COLOR_CODE_CLOSE,1,0,0,true)
        end
        --AutoScrapTooltip:AddDoubleLine("prob", "lala")
        GameTooltip:Show()
    end)
    parentFrame:HookScript("OnLeave", function(self)
        GameTooltip:Hide()
    end)
end

z.c = CreateFrame("Button", nil, z)
z.c:SetNormalTexture(130832) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Up"
z.c:SetPushedTexture(130830) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Down"
z.c:SetHighlightTexture(130831) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight"
z.c:SetSize(32, 32)
z.c:SetPoint("TOPRIGHT", z, "TOPRIGHT", 0, -3)
z.c:SetScript("OnClick", function() ns.ocultarFrames() end)

local titleFrame = ns.Utils.crearFrameConTextura(z,275,430,327,405,1)
titleFrame:SetPoint("TOP", z, "TOP", -3, -29)

local ilevel = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
ilevel:SetPoint("TOPLEFT", z, "TOPLEFT", 58, -100);
local itemLevelText = L["ItemLevel: "]
ilevel.text:SetText(itemLevelText..AutoScrap_CharSettings.iLevel);
ilevel:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedIlevel = self:GetChecked()
end)
local function setProtectIlevel (value)
    ilevel:SetChecked(value)
end
ns.setProtectIlevel = setProtectIlevel

local dialog
ilevel.bSet = CreateFrame("Button", nil, z, "UIPanelButtonTemplate")
ilevel.bSet:SetPoint("TOPRIGHT",ilevel,"TOPLEFT",0,-5)
ilevel.bSet:SetSize(30, 18)
ilevel.bSet:SetText("Set")
ilevel.bSet:SetScript("OnClick", function(self, button)
	if(button == "LeftButton") then
        dialog:Show()
    end
end)

local ratio = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
ratio:SetPoint("TOPLEFT", ilevel, "TOPLEFT", 0, -22);
local sellRatioText = L["Sell Rate: "]
ratio.text:SetText(sellRatioText..AutoScrap_CharSettings.sellRatio);
ratio:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedRatio = self:GetChecked()
end)
local function setProtectRatio (value)
    ratio:SetChecked(value)
end
ns.setProtectRatio = setProtectRatio

local dialog2
ratio.bSet = CreateFrame("Button", nil, z, "UIPanelButtonTemplate")
ratio.bSet:SetPoint("TOPRIGHT",ratio,"TOPLEFT",0,-5)
ratio.bSet:SetSize(30, 18)
ratio.bSet:SetText("Set")
ratio.bSet:SetScript("OnClick", function(self, button)
	if(button == "LeftButton") then
        dialog2:Show()
    end
end)

local consumables = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
consumables:SetPoint("TOPLEFT", ratio, "TOPLEFT", -29, -28);
consumables.text:SetText(L["Consumables"]);
consumables:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedConsumables = self:GetChecked()
    ns.changeItemClass("Consumables",not AutoScrap_CharSettings.protectedConsumables)
end)
local function setConsumables (value)
    consumables:SetChecked(value)
end
ns.setConsumables = setConsumables

------------
local recipes = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
recipes:SetPoint("TOPLEFT", consumables, "TOPLEFT", 0, -22);
recipes.text:SetText(L["Recipes"]);
recipes:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedRecipes = self:GetChecked()
    ns.changeItemClass("Recipes",not AutoScrap_CharSettings.protectedRecipes)
end)
local function setRecipes (value)
    recipes:SetChecked(value)
end
ns.setRecipes = setRecipes

local cooking = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
cooking:SetPoint("TOPLEFT", recipes, "TOPLEFT", 0, -22);
cooking.text:SetText(L["Cooking"]);
cooking:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedCooking = self:GetChecked()
    ns.changeItemClass("Cooking",not AutoScrap_CharSettings.protectedCooking)
end)
local function setCooking (value)
    cooking:SetChecked(value)
end
ns.setCooking = setCooking

local leather = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
leather:SetPoint("TOPLEFT", cooking, "TOPLEFT", 0, -22);
leather.text:SetText(L["Leather"]);
leather:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedLeather = self:GetChecked()
    ns.changeItemClass("Leather",not AutoScrap_CharSettings.protectedLeather)
end)
local function setLeather (value)
    leather:SetChecked(value)
end
ns.setLeather = setLeather

local cloths = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
cloths:SetPoint("TOPLEFT", recipes, "TOPRIGHT", 45, 0);
cloths.text:SetText(L["Cloths"]);
cloths:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedCloths = self:GetChecked()
    ns.changeItemClass("Cloths",not AutoScrap_CharSettings.protectedCloths)
end)
local function setCloths (value)
    cloths:SetChecked(value)
end
ns.setCloths = setCloths

local herbs = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
herbs:SetPoint("TOPLEFT", cooking, "TOPRIGHT", 45, 0);
herbs.text:SetText(L["Herbs"]);
herbs:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedHerbs = self:GetChecked()
    ns.changeItemClass("Herbs",not AutoScrap_CharSettings.protectedHerbs)
end)
local function setHerbs (value)
    herbs:SetChecked(value)
end
ns.setHerbs = setHerbs

local mining = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
mining:SetPoint("TOPLEFT", leather, "TOPRIGHT", 45, 0);
mining.text:SetText(L["Mining"]);
mining:SetScript("OnClick", function (self)
    ns.toggleAutoScrapOff()
    AutoScrap_CharSettings.protectedMining = self:GetChecked()
    ns.changeItemClass("Mining",not AutoScrap_CharSettings.protectedMining)
end)
local function setMining (value)
    mining:SetChecked(value)
end
ns.setMining = setMining


------------


local limpiarTODO = CreateFrame("Button", nil, z, "UIPanelButtonTemplate")
limpiarTODO:SetPoint("CENTER",z,"TOP",0,-272)
limpiarTODO:SetSize(130, 40)
limpiarTODO:SetText(L["Empty the entire\nScrap list"])
limpiarTODO:SetScript("OnClick", function(self, button)
	if(button == "LeftButton") then
        --ns.toggleAutoScrapOff()
        if Scrap_Sets and Scrap_Sets.list then
            Scrap_Sets["list"] = {}
        end
        if Scrap_CharSets and Scrap_CharSets.list then
            Scrap_CharSets["list"] = {}
        end
        PlaySound(148283)
        ReloadUI()
    end
end)


local function setIlevel()
    ilevel.text:SetText(itemLevelText..AutoScrap_CharSettings.iLevel);
end
ns.setIlevel = setIlevel

local function setSellRatio()
    ratio.text:SetText(sellRatioText..AutoScrap_CharSettings.sellRatio);
end
ns.setSellRatio = setSellRatio

--[[ local applyRatio = CreateFrame("CheckButton", nil, z, "UICheckButtonTemplate");
applyRatio:SetPoint("TOPLEFT",ratio, "TOPLEFT", 0, -22);
applyRatio.text:SetText("");
applyRatio.text:SetJustifyH("LEFT") ]]



--diálogo ilevel
dialog = CreateFrame("Frame", nil, UIParent, "BackdropTemplate")
dialog:SetPoint("CENTER",0,-50)
dialog:SetSize(150, 40)
dialog:SetFrameStrata("DIALOG")
dialog:SetClipsChildren(true)
dialog:SetBackdrop({
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
    edgeFile = "Interface\\PVPFrame\\UI-Character-PVP-Highlight",
    edgeSize = 16,
    insets = { left = 4, right = 4, top = 4, bottom = 4 },
})
dialog:SetBackdropBorderColor(225/255, 143/256, 60/255  , 0.7)
--:SetVertexColor(r, g, b [, a])

local function comprobarNumeros(value)
    local err = tonumber(value)
    if(err and err%1==0 and err>=1 and err<=999)then
        AutoScrap_CharSettings.iLevel=err
        ns.updateUI()
    end
end

local eb = CreateFrame("EditBox", nil, dialog)
eb:SetSize(100, 40)
eb:SetMaxLetters(7)
eb:SetPoint("LEFT", dialog, "LEFT", 10, 0)
eb:SetMultiLine(false)
eb:SetAutoFocus(true) -- probar false
eb:SetFontObject("ChatFontNormal")
eb:SetText("184")
eb:HighlightText(0)
eb:SetScript("OnEscapePressed",function() dialog:Hide() end)
eb:SetScript("OnEnterPressed",function() dialog:Hide() comprobarNumeros(eb:GetText()) end)

local dialogButton = CreateFrame("Button", nil, dialog, "UIPanelButtonTemplate")
--dialogButton:SetNormalTexture(130832) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Up"
--dialogButton:SetPushedTexture(130830) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Down"
--dialogButton:SetHighlightTexture(130831) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight"
dialogButton:SetSize(30, 22)
dialogButton:SetText("Set")
dialogButton:SetPoint("RIGHT", dialog, "RIGHT", -8, 0)
dialogButton:SetScript("OnClick", function() dialog:Hide() comprobarNumeros(eb:GetText()) end)

dialog:Hide()
--fin diálogo ilevel

--diálogo ratio
dialog2 = CreateFrame("Frame", nil, UIParent, "BackdropTemplate")
dialog2:SetPoint("CENTER",0,-100)
dialog2:SetSize(150, 40)
dialog2:SetFrameStrata("DIALOG")
dialog2:SetClipsChildren(true)
dialog2:SetBackdrop({
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
    edgeFile = "Interface\\PVPFrame\\UI-Character-PVP-Highlight",
    edgeSize = 16,
    insets = { left = 4, right = 4, top = 4, bottom = 4 },
})
dialog2:SetBackdropBorderColor(225/255, 143/256, 60/255  , 0.7)
--:SetVertexColor(r, g, b [, a])

local function comprobarNumerosRate(value)
    value=value:gsub("%,", ".")
    local err = tonumber(value)
    if(err and err>=0.01 and err<=1)then
        err = math.floor(err * 100+ 0.5) / 100
        AutoScrap_CharSettings.sellRatio=err
        ns.updateUI()
    end
end

local eb2 = CreateFrame("EditBox", nil, dialog2)
eb2:SetSize(100, 40)
eb2:SetMaxLetters(7)
eb2:SetPoint("LEFT", dialog2, "LEFT", 10, 0)
eb2:SetMultiLine(false)
eb2:SetAutoFocus(true) -- probar false
eb2:SetFontObject("ChatFontNormal")
eb2:SetText("0.2")
eb2:HighlightText(0)
eb2:SetScript("OnEscapePressed",function() dialog2:Hide() end)
eb2:SetScript("OnEnterPressed",function() dialog2:Hide() comprobarNumerosRate(eb2:GetText()) end)

local dialog2Button = CreateFrame("Button", nil, dialog2, "UIPanelButtonTemplate")
--dialog2Button:SetNormalTexture(130832) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Up"
--dialog2Button:SetPushedTexture(130830) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Down"
--dialog2Button:SetHighlightTexture(130831) --"Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight"
dialog2Button:SetSize(30, 22)
dialog2Button:SetText("Set")
dialog2Button:SetPoint("RIGHT", dialog2, "RIGHT", -8, 0)
dialog2Button:SetScript("OnClick", function() dialog2:Hide() comprobarNumerosRate(eb2:GetText()) end)

dialog2:Hide()
--fin diálogo ratio

z:Hide()

setTooltip(titleFrame,L["Your Protection tab"],L["All the setup here will work as opposite of Main Window, items won't be sold if they are equal or higher than the values of iLevel and ratio. Also you can protect some item class, or unprotect them if you don't care about them."])
setTooltip(ilevel,L["Item Level"],L["If you enable it you will keep on your inventory all items with this iLevel or higher."],L["If you check Accesories, whites or grays in the MainWindow to be always sold, they won't be affected by this stat, they have their own config."])
setTooltip(ratio,L["Sell Ratio on Auction House"],L["If you enable it you will keep on your inventory all the items with that ratio of selling in the acution house or higher"],L["If you check Accesories, whites or grays in the MainWindow to be always sold, they won't be affected by this stat, they have their own config."])
setTooltip(consumables,L["Consumables"],L["Protect all the consumable items for being sold, as potions, food that heals you, etc.."],L["If you have a white list with your inventory consumables, I recommend you to untick this group, because most consumables are junk."])
setTooltip(recipes,L["Recipes"],L["Protect all the recipes for being sold."],L["Remember that untick a group doesn't mean you sell all of them, they will be sold only if they worth less value of MainWindow slider gold"])
setTooltip(cooking,L["Cooking"],L["Protect all the cooking stuff for being sold."],L["Remember that untick a group doesn't mean you sell all of them, they will be sold only if they worth less value of MainWindow slider gold"])
setTooltip(leather,L["Leather"],L["Protect all the leather for being sold."],L["Remember that untick a group doesn't mean you sell all of them, they will be sold only if they worth less value of MainWindow slider gold"])
setTooltip(cloths,L["Cloths"],L["Protect all the Cloths (tradeskill cloths) for being sold."],L["Remember that untick a group doesn't mean you sell all of them, they will be sold only if they worth less value of MainWindow slider gold"])
setTooltip(herbs,L["Herbs"],L["Protect all the herbs for being sold."],L["Remember that untick a group doesn't mean you sell all of them, they will be sold only if they worth less value of MainWindow slider gold"])
setTooltip(mining,L["Mining"],L["Protect all the metal and ore for being sold."],L["Remember that untick a group doesn't mean you sell all of them, they will be sold only if they worth less value of MainWindow slider gold"])
setTooltip(limpiarTODO,L["Empty Scrap List"],L["This will delete all the current Scrap item list. Usually you want to do this when the prices has changed after long time playing."],L["**Requiere reload the UI**"])


